create or replace package PKG_P8PANELS_MECHREC as

  /*            */
  procedure FCPRODPLANSP_GET
  (
    NFCPRODPLAN             in number,         -- .  
    NLEVEL                  in number := null, --  
    COUT                    out clob,          --  
    NMAX_LEVEL              out number         --   
  );
  
  /*        */
  procedure PRODPLAN_INIT
  (
    COUT                    out clob    --      
  );

end PKG_P8PANELS_MECHREC;
/
create or replace package body PKG_P8PANELS_MECHREC as

  /*  -   */
  SBG_COLOR_RED             constant PKG_STD.TSTRING := 'red';        --    (  != 0)
  SBG_COLOR_YELLOW          constant PKG_STD.TSTRING := '#e0db44';    --    (  = 0    = 0)
  SBG_COLOR_GREEN           constant PKG_STD.TSTRING := 'lightgreen'; --    (  = 0)
  SBG_COLOR_BLACK           constant PKG_STD.TSTRING := 'black';      --    (   )
  STEXT_COLOR_ORANGE        constant PKG_STD.TSTRING := '#FF8C00';    --      ()
  
  /*  -    */
  NFCPRODPLAN_CATEGORY      constant PKG_STD.TNUMBER := 1;            --   " "
  NFCPRODPLAN_STATUS        constant PKG_STD.TNUMBER := 2;            --   ""
  SFCPRODPLAN_TYPE          constant PKG_STD.TSTRING := '';       --   ( )
  
  /*  -   */
  STASK_ATTR_DEFRESLIZ      constant PKG_STD.TSTRING := 'defresliz';  --  
  STASK_ATTR_REL_FACT       constant PKG_STD.TSTRING := 'rel_fact';   --  
  STASK_ATTR_DEFSTART       constant PKG_STD.TSTRING := 'defstart';   --  
  STASK_ATTR_LEVEL          constant PKG_STD.TSTRING := 'level';      -- 

  /*      */
  procedure MAKE_GANT_ITEM
  (
    NDEFRESLIZ              in number,    --  
    NREL_FACT               in number,    --  
    NDEFSTART               in number,    --  
    STASK_BG_COLOR          out varchar2, --   
    STASK_BG_PROGRESS_COLOR out varchar2, --     
    NTASK_PROGRESS          out number    --  
  )
  is
  begin
    /*    <> 0 */
    if (NDEFRESLIZ <> 0) then
      /*   */
      STASK_BG_COLOR          := SBG_COLOR_RED;
      STASK_BG_PROGRESS_COLOR := null;
      NTASK_PROGRESS          := null;
    else
      /*    = 0 */
      if (NDEFSTART = 0) then
        /*   */
        STASK_BG_COLOR          := SBG_COLOR_GREEN;
        STASK_BG_PROGRESS_COLOR := null;
        NTASK_PROGRESS          := null;
      else
        /*    = 0    = 0 */
        if ((NDEFRESLIZ = 0) and (NREL_FACT = 0)) then
          /*   */
          STASK_BG_COLOR          := SBG_COLOR_YELLOW;
          STASK_BG_PROGRESS_COLOR := null;
          NTASK_PROGRESS          := null;
        end if;
        /*    = 0    <> 0 */
        if ((NDEFRESLIZ = 0) and (NREL_FACT <> 0)) then
          /*  ,   */
          STASK_BG_COLOR          := SBG_COLOR_GREEN;
          STASK_BG_PROGRESS_COLOR := SBG_COLOR_YELLOW;
          NTASK_PROGRESS          := 50;
        end if;
      end if;
    end if;
  end MAKE_GANT_ITEM;
  
  /*    */
  function TITLE_GET
  (
    NRN                     in number        -- .      
  ) return                  varchar2         --   
  is
    SRESULT                 PKG_STD.TSTRING; --   
    SDOC_INFO               PKG_STD.TSTRING; --   
    SJURPERSONS_CODE        PKG_STD.TSTRING; --  
    SINS_DEPARTMENT_CODE    PKG_STD.TSTRING; --  
  begin
    /*     */
    begin
      select D.DOCCODE || ', ' || trim(T.PREFIX) || '/' || trim(T.NUMB) || ',  ' || TO_CHAR(T.DOCDATE, 'dd.mm.yyyy') DOC_INFO,
             J.CODE,
             SD.CODE
        into SDOC_INFO,
             SJURPERSONS_CODE,
             SINS_DEPARTMENT_CODE
        from FCPRODPLAN     T,
             DOCTYPES       D,
             JURPERSONS     J,
             INS_DEPARTMENT SD
       where T.RN = NRN
         and D.RN = T.DOCTYPE
         and J.RN = T.JUR_PERS
         and SD.RN = T.SUBDIV;
    exception
      when others then
        return ' .';
    end;
    /*   */
    SRESULT := '     "' || SDOC_INFO || '",  "' || SJURPERSONS_CODE ||
               '",  "' || SINS_DEPARTMENT_CODE || '"';
    /*   */
    return SRESULT;
  end TITLE_GET;
  
  /*      */
  function PRODPLAN_MAX_LEVEL_GET
  (
    NPRODPLAN               in number        -- .  
  ) return                  number           --   
  is
    NRESULT                 PKG_STD.TNUMBER; --   
  begin
    /*    */
    begin
      select max(level)
        into NRESULT
        from (select T.RN,
                     T.UP_LEVEL
                from FCPRODPLANSP T
               where T.PRN = NPRODPLAN) TMP
      connect by prior TMP.RN = TMP.UP_LEVEL
       start with TMP.UP_LEVEL is null;
    exception
      when others then
        NRESULT := null;
    end;
    /*   */
    return NRESULT;
  end PRODPLAN_MAX_LEVEL_GET;
  
  /*     */
  procedure FCPRODPLANSP_DATES_GET
  (
    DREP_DATE               in date,        --   
    DREP_DATE_TO            in date,        --   
    DINCL_DATE              in date,        --     
    NHAVE_LINK              in number := 0, --    " "  "  "
    DDATE_FROM              out date,       --    
    DDATE_TO                out date,       --    
    STASK_BG_COLOR          out varchar2,   --   (,       ,  null)
    STASK_TEXT_COLOR        out varchar2,   --    (,       ,  null)
    NTASK_PROGRESS          out number      --   ( null,       )
  )
  is
  begin
    /*     */
    STASK_BG_COLOR   := null;
    NTASK_PROGRESS   := null;
    STASK_TEXT_COLOR := null;
    /*       */
    if ((DREP_DATE is null) and (DREP_DATE_TO is null)) then
      /*      */
      DDATE_FROM := DINCL_DATE;
      DDATE_TO   := DINCL_DATE;
    else
      /*      / */
      DDATE_FROM := COALESCE(DREP_DATE, DREP_DATE_TO);
      DDATE_TO   := COALESCE(DREP_DATE_TO, DREP_DATE);
    end if;
    /*       */
    if ((DREP_DATE is null) or (DREP_DATE_TO is null)) then
      /*       */
      if (NHAVE_LINK = 0) then
        /*    */
        STASK_BG_COLOR   := SBG_COLOR_BLACK;
        STASK_TEXT_COLOR := STEXT_COLOR_ORANGE;
        NTASK_PROGRESS   := null;
      end if;
    end if;
  end FCPRODPLANSP_DATES_GET;

  /*            */
  procedure FCPRODPLANSP_GET
  (
    NFCPRODPLAN             in number,                       -- .  
    NLEVEL                  in number := null,               --  
    COUT                    out clob,                        --  
    NMAX_LEVEL              out number                       --   
  )
  is
    /*  */
    RG                      PKG_P8PANELS_VISUAL.TGANTT;      --   
    RGT                     PKG_P8PANELS_VISUAL.TGANTT_TASK; --    
    BREAD_ONLY_DATES        boolean := false;                --       
    STASK_BG_COLOR          PKG_STD.TSTRING;                 --   
    STASK_TEXT_COLOR        PKG_STD.TSTRING;                 --   
    STASK_BG_PROGRESS_COLOR PKG_STD.TSTRING;                 --    
    NTASK_PROGRESS          PKG_STD.TNUMBER;                 --   
    DDATE_FROM              PKG_STD.TLDATE;                  --   
    DDATE_TO                PKG_STD.TLDATE;                  --   
  begin
    /*    */
    RG := PKG_P8PANELS_VISUAL.TGANTT_MAKE(STITLE              => TITLE_GET(NRN => NFCPRODPLAN),
                                          NZOOM               => PKG_P8PANELS_VISUAL.NGANTT_ZOOM_DAY,
                                          BREAD_ONLY_DATES    => BREAD_ONLY_DATES,
                                          BREAD_ONLY_PROGRESS => true);
    /*      */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT   => RG,
                                             SNAME    => STASK_ATTR_DEFRESLIZ,
                                             SCAPTION => ' ');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT   => RG,
                                             SNAME    => STASK_ATTR_REL_FACT,
                                             SCAPTION => ' ');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT   => RG,
                                             SNAME    => STASK_ATTR_DEFSTART,
                                             SCAPTION => ' ');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_ATTR(RGANTT => RG, SNAME => STASK_ATTR_LEVEL, SCAPTION => '');
    /*    */
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_RED,
                                              SDESC     => '          != 0.');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_YELLOW,
                                              SDESC     => '          = 0    = 0.');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT    => RG,
                                              SBG_COLOR => SBG_COLOR_GREEN,
                                              SDESC     => '          = 0.');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT             => RG,
                                              SBG_COLOR          => SBG_COLOR_GREEN,
                                              SBG_PROGRESS_COLOR => SBG_COLOR_YELLOW,
                                              SDESC              => '          = 0    != 0. ');
    PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK_COLOR(RGANTT      => RG,
                                              SBG_COLOR   => SBG_COLOR_BLACK,
                                              STEXT_COLOR => STEXT_COLOR_ORANGE,
                                              SDESC       => '                         .');
    /*     */
    NMAX_LEVEL := PRODPLAN_MAX_LEVEL_GET(NPRODPLAN => NFCPRODPLAN);
    /*        */
    for REC in (select TMP.*,
                       level
                  from (select T.RN,
                               T.REP_DATE,
                               T.REP_DATE_TO,
                               T.INCL_DATE,
                               T.ROUTE,
                               D.NOMEN_NAME,
                               (T.QUANT_REST - T.START_FACT) DEFRESLIZ,
                               T.REL_FACT,
                               (T.MAIN_QUANT - T.REL_FACT) DEFSTART,
                               (select 1
                                  from DUAL
                                 where exists
                                 (select null
                                          from DOCLINKS L
                                         where L.IN_DOCUMENT = T.RN
                                           and L.IN_UNITCODE = 'CostProductPlansSpecs'
                                           and (L.OUT_UNITCODE = 'CostRouteLists' or L.OUT_UNITCODE = 'IncomFromDeps')
                                           and ROWNUM = 1)) HAVE_LINK,
                               T.UP_LEVEL
                          from FCPRODPLANSP  T,
                               FCMATRESOURCE FM,
                               DICNOMNS      D
                         where T.PRN = NFCPRODPLAN
                           and ((T.REP_DATE is not null) or (T.REP_DATE_TO is not null) or (T.INCL_DATE is not null))
                           and FM.RN = T.MATRES
                           and D.RN = FM.NOMENCLATURE) TMP
                 where ((NLEVEL is null) or ((NLEVEL is not null) and (level <= NLEVEL)))
                connect by prior TMP.RN = TMP.UP_LEVEL
                 start with TMP.UP_LEVEL is null)
    loop
      /*     ( ) */
      FCPRODPLANSP_DATES_GET(DREP_DATE        => REC.REP_DATE,
                             DREP_DATE_TO     => REC.REP_DATE_TO,
                             DINCL_DATE       => REC.INCL_DATE,
                             NHAVE_LINK       => COALESCE(REC.HAVE_LINK, 0),
                             DDATE_FROM       => DDATE_FROM,
                             DDATE_TO         => DDATE_TO,
                             STASK_BG_COLOR   => STASK_BG_COLOR,
                             STASK_TEXT_COLOR => STASK_TEXT_COLOR,
                             NTASK_PROGRESS   => NTASK_PROGRESS);
      /*         */
      if (STASK_BG_COLOR is null) then
        /*     */
        MAKE_GANT_ITEM(NDEFRESLIZ              => REC.DEFRESLIZ,
                       NREL_FACT               => REC.REL_FACT,
                       NDEFSTART               => REC.DEFSTART,
                       STASK_BG_COLOR          => STASK_BG_COLOR,
                       STASK_BG_PROGRESS_COLOR => STASK_BG_PROGRESS_COLOR,
                       NTASK_PROGRESS          => NTASK_PROGRESS);
      end if;
      /*    */
      RGT := PKG_P8PANELS_VISUAL.TGANTT_TASK_MAKE(NRN                 => REC.RN,
                                                  SNUMB               => COALESCE(REC.ROUTE, ''),
                                                  SCAPTION            => REC.NOMEN_NAME,
                                                  SNAME               => REC.NOMEN_NAME,
                                                  DSTART              => DDATE_FROM,
                                                  DEND                => DDATE_TO,
                                                  NPROGRESS           => NTASK_PROGRESS,
                                                  SBG_COLOR           => STASK_BG_COLOR,
                                                  STEXT_COLOR         => STASK_TEXT_COLOR,
                                                  SBG_PROGRESS_COLOR  => STASK_BG_PROGRESS_COLOR,
                                                  BREAD_ONLY          => true,
                                                  BREAD_ONLY_DATES    => true,
                                                  BREAD_ONLY_PROGRESS => true);
      /*  .  */
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => STASK_ATTR_DEFRESLIZ,
                                                   SVALUE => TO_CHAR(REC.DEFRESLIZ),
                                                   BCLEAR => true);
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => STASK_ATTR_REL_FACT,
                                                   SVALUE => TO_CHAR(REC.REL_FACT));
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => STASK_ATTR_DEFSTART,
                                                   SVALUE => TO_CHAR(REC.DEFSTART));
      PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_ATTR_VAL(RGANTT => RG,
                                                   RTASK  => RGT,
                                                   SNAME  => STASK_ATTR_LEVEL,
                                                   SVALUE => REC.LEVEL);
      /*   */
      for LINK in (select T.RN
                     from FCPRODPLANSP T
                    where T.PRN = NFCPRODPLAN
                      and T.UP_LEVEL = REC.RN
                      and ((NLEVEL is null) or ((NLEVEL is not null) and (NLEVEL >= REC.LEVEL + 1))))
      loop
        /*   */
        PKG_P8PANELS_VISUAL.TGANTT_TASK_ADD_DEPENDENCY(RTASK => RGT, NDEPENDENCY => LINK.RN);
      end loop;
      /*      */
      PKG_P8PANELS_VISUAL.TGANTT_ADD_TASK(RGANTT => RG, RTASK => RGT);
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TGANTT_TO_XML(RGANTT => RG);
  end FCPRODPLANSP_GET;

  /*        */
  procedure PRODPLAN_INIT
  (
    COUT                    out clob    --      
  )
  is
  begin
    /*   XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    /*   */
    PKG_XFAST.DOWN_NODE(SNAME => 'XDATA');
    /*        */
    for REC in (select T.RN NRN,
                       D.DOCCODE || ', ' || trim(T.PREFIX) || '/' || trim(T.NUMB) || ', ' ||
                       TO_CHAR(T.DOCDATE, 'dd.mm.yyyy') SDOC_INFO
                  from FCPRODPLAN T,
                       DOCTYPES   D,
                       FINSTATE   FS
                 where T.CATEGORY = NFCPRODPLAN_CATEGORY
                   and T.STATUS = NFCPRODPLAN_STATUS
                   and D.RN = T.DOCTYPE
                   and FS.RN = T.TYPE
                   and FS.CODE = SFCPRODPLAN_TYPE
                   and exists (select /*+ INDEX(UP I_USERPRIV_CATALOG_ROLEID) */
                         null
                          from USERPRIV UP
                         where UP.CATALOG = T.CRN
                           and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                              UR.ROLEID
                                               from USERROLES UR
                                              where UR.AUTHID = UTILIZER)
                        union all
                        select /*+ INDEX(UP I_USERPRIV_CATALOG_AUTHID) */
                         null
                          from USERPRIV UP
                         where UP.CATALOG = T.CRN
                           and UP.AUTHID = UTILIZER)
                   and exists (select /*+ INDEX(UP I_USERPRIV_JUR_PERS_ROLEID) */
                         null
                          from USERPRIV UP
                         where UP.JUR_PERS = T.JUR_PERS
                           and UP.UNITCODE = 'CostProductPlans'
                           and UP.ROLEID in (select /*+ INDEX(UR I_USERROLES_AUTHID_FK) */
                                              UR.ROLEID
                                               from USERROLES UR
                                              where UR.AUTHID = UTILIZER)
                        union all
                        select /*+ INDEX(UP I_USERPRIV_JUR_PERS_AUTHID) */
                         null
                          from USERPRIV UP
                         where UP.JUR_PERS = T.JUR_PERS
                           and UP.UNITCODE = 'CostProductPlans'
                           and UP.AUTHID = UTILIZER)
                 order by T.DOCDATE desc)
    loop
      /*   */
      PKG_XFAST.DOWN_NODE(SNAME => 'XFCPRODPLANS');
      /*   */
      PKG_XFAST.ATTR(SNAME => 'NRN', NVALUE => REC.NRN);
      PKG_XFAST.ATTR(SNAME => 'SDOC_INFO', SVALUE => REC.SDOC_INFO);
      /*   */
      PKG_XFAST.UP();
    end loop;
    /*   */
    PKG_XFAST.UP();
    /*  */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    /*   XML */
    PKG_XFAST.EPILOGUE();
  exception
    when others then
      /*   XML */
      PKG_XFAST.EPILOGUE();
      /*   */
      PKG_STATE.DIAGNOSTICS_STACKED();
      P_EXCEPTION(0, PKG_STATE.SQL_ERRM());
  end PRODPLAN_INIT;

end PKG_P8PANELS_MECHREC;
/
